## Network Survey Android App Privacy Policy

Christian Rowlands built the Network Survey app as an Open Source app. This App is provided by Christian Rowlands at no cost and is intended for use as is.

This page is used to inform visitors regarding my policies with the collection, use, and disclosure of Personal Information if anyone decided to use the App.

If you choose to use my Service, then you agree to the collection and use of information in relation to this policy. The Personal Information that I collect is
used for providing and improving the Service. I will not use or share your information with anyone except as described in this Privacy Policy.

**Information Collection and Use**

For a better experience, while using our Service, I may require you to provide us with certain personally identifiable
information, including but not limited to Location. The information that I request will be retained on your device and
is not collected by me in any way.

The app does use third party services that may collect information used to identify you.

Links to the privacy policy of third party service providers used by the app

* [Google Play Services](https://www.google.com/policies/privacy/)
* [Google Analytics for Firebase](https://www.google.com/analytics/terms/)
* [Firebase Crashlytics](https://firebase.google.com/support/privacy/)

If you installed this app from the Google Play store then Firebase Crashlytics and Analytics information is stored in Google Firebase. This data is anonymous
but data related to app crashes and general app usage is set to Google Firebase to improve the stability and functionality of this app. This data is not sold
or provided to any other 3rd party entities by Christian Rowlands or anyone working on the Network Survey Android project.

No other information is stored external to the Network Survey Android app unless configured to by the user. All survey log files remain
on the phone unless you, the user, moves the. All connections including MQTT and gRPC server connections have to be
configured and initiated by the user, and a default server is not provided.

**Background Location Permission**

The Network Survey Android app requests permission to access the device's location in the background. This background location
permission is needed to start Network Survey at boot. Denying the background location permission will prevent the auto-start
at boot location feature from working correctly, but all other app functionality will work as expected.

**Location Permission**

In addition to the Background Location Permission, the Network Survey Android app requests the Location Permission. This
location permission is critical to the apps core functionality. The location permission is needed to obtain cellular,
Wi-Fi, and GNSS survey records. In addition, each survey record is recorded with the device's current location to enable
follow on analysis of the Cellular, Wi-Fi, Bluetooth and GNSS survey records.

The location data consumed by the Network Survey app is recorded to the GeoPackage log files, if logging is enabled. The
location data is also sent over MQTT and gRPC to a remote server, if a remote server is configured. There is not a default
remote server provided with the app, so it is necessary for the user of the Network Survey app to stand up their own
server to receive that information. The location data is not used in any other way than defined above. The location data
is not shared with any 3rd parties, and is not accessible by anyone except for the user. Therefore, the location data
is not collection, used, or shared by or with anyone that the user has not directly handed the data to by uploading
the recorded GeoPackage or sent to by connecting to someone else's MQTT or gRPC server.

**Tower Map View Location Data**

If you use the tower map view feature, the request to the server will contain the location of the map view. This 
location data is stored in the server logs for 90 days and then deleted. The location data is anonymous and is not 
tied to any specific user. Use of the map view is optional and a privacy warning is displayed when the map view is
used for the first time.

**Log Data**

The App has the capability to log information to a GeoPackage file, but that file remains on your device and it is up to you
if you want to copy the file off the device to another device of your choosing.

**Changes to This Privacy Policy**

I may update our Privacy Policy from time to time. Thus, you are advised to review this page periodically for any changes. I will
notify you of any changes by posting the new Privacy Policy on this page. These changes are effective immediately after they are posted on this page.

**Contact Us**

If you have any questions or suggestions about my Privacy Policy, do not hesitate to contact me at craxiomdev@gmail.com.

This privacy policy page was created at [privacypolicytemplate.net](https://privacypolicytemplate.net) and modified/generated by [App Privacy Policy Generator](https://app-privacy-policy-generator.firebaseapp.com/)
